SystemOrganization addCategory: #'GBT-DSL_EFA'!

Object subclass: #Auswertungen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Auswertungen class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:07'!
auswertungenContext 
	"comment stating purpose of message"
	
	^GbtPlainAC struct: 'Auswertungen' define: {
		{#displayAs: . 'Auswertungen'} .
		{#uiSpec:icon: . #GbtListAndItemUI . #beitragsMgmt16} .
		{#templates: . self fahrtContext} .
		{#loadPolicy: . #autoload } .
		{#display: . #( #(bootsName Boot) #(steuermann Steuermann) #(abfahrt Abfahrt))} .
		{#subcontext: . self fahrtContext}
		}
! !

Object subclass: #EFA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!EFA class methodsFor: 'contexts' stamp: 'hk 3/23/2017 15:52'!
efa
"EFA efa open"
	^ GbtPlainAC struct: #EFA define:
			{{#aspect:on:. Fahrtenbuch fahrtenBuchContext. nil}.
			{#aspect:on:. Boote booteContext. nil}.
			{#aspect:on:. Personen personenContext. nil}.
			{#aspect:on:. Beitragsmanagement beitragsmanagementContext. nil}.
			{#aspect:on:. Statistics statisticsContext. nil}.
			{#uiSpec:icon: . #GbtMainUI . #efa}.
			{#displayAs: . #EFA}.
			{#extent:. (1200 @ 800)}.
			{#legalText: . 'GloConn International © 2016'}}! !

!EFA class methodsFor: 'example' stamp: 'hk 3/14/2017 13:08'!
exampleClear
	GbtBizAppServer clearStore. 
	GbtSVO initialize. 
! !

!EFA class methodsFor: 'example' stamp: 'hk 8/18/2016 16:45'!
exampleData
	self storeTestFahrten.
	self storeTestPersonen.
	self storeTestBoote.
	self storeTestBeitragstabellen.
"	self storeBeitragsmanagement.
	self storeBeitragsabrechnungen.
"	! !

!EFA class methodsFor: 'example' stamp: 'hk 11/11/2016 13:54'!
exampleRun
	self login open
! !

!EFA class methodsFor: 'contexts' stamp: 'hk 3/14/2017 10:36'!
installUsers
		#(Tom Lisa) do: [:u| GbtBizAppServer default addUser: u withRole: GbtRole forExecute ].
		#(Tony Robert) do: [:u| GbtBizAppServer default addUser: u withRole: GbtRole forWrite ].
		#(Bob) do: [:u| GbtBizAppServer default addUser: u withRole: GbtRole forRead ]! !

!EFA class methodsFor: 'contexts' stamp: 'hk 3/22/2017 17:38'!
login
	self installUsers.
	^ GbtLoginAC
		struct: 'EFALogin'
		define:
			{{#uiSpec:icon: . nil . #efa}.
			{#displayAs: . #EFA}.
			{#appClass:selector: . #EFA . #efa}.
			{#legalText: . 'GloConn International © 2016'}}! !

!EFA class methodsFor: 'test data' stamp: 'CC 8/12/2016 18:53'!
storeBeitragsmanagement
	Beitragsmanagement beitragsmanagement01
! !

!EFA class methodsFor: 'test data' stamp: 'CC 8/7/2016 18:52'!
storeTestBeitragstabellen
	Beitragstabellen beitragstabellenliste1! !

!EFA class methodsFor: 'test data' stamp: 'CC 8/7/2016 18:07'!
storeTestBoote
	Boote booteListe1! !

!EFA class methodsFor: 'example' stamp: 'hk 8/11/2016 12:58'!
storeTestFahrten
	Fahrtenbuch  storeTestFahrten! !

!EFA class methodsFor: 'test data' stamp: 'CC 8/7/2016 17:45'!
storeTestPersonen
	Personen personenListe1
! !

Object subclass: #Fahrtenbuch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Fahrtenbuch class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
besatzung
	"self besatzung edit"
	^GbtThing struct: 'Besatzung' define: {
		{ #summary . 'system template'}.
		{ #Steuermann . #thing: .  self ruderer}.
		{ #Mannschaft . #listOf: .  self ruderer}.
	}! !

!Fahrtenbuch class methodsFor: 'examples' stamp: 'hk 3/22/2017 17:48'!
exampleRun
	GbtBizAppServer initialize. GbtSVO initialize.
	(self fahrtenBuchContext) ui title: #Fahrtenbuch; open! !

!Fahrtenbuch class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
fahrt
	^ GbtThing
		struct: 'Fahrt'
		define:
			{{#summary . '#bizId : #Steuermann:RudererName #Mannschaft ab: #Abfahrt an: #Ankunft'}.
			{#idNumberPolicy . #FahrtNoPolicy}.
			{#Datum.
			#date:.
			Date today}.
			{#Boot.
			#thing:.
			Boote boot}.
			{#Besatzung.
			#thing:.
			self besatzung}.
			{#Abfahrt . #date: . '1 July 2016'}.
			{#Ankunft . #date: . '2 July 2016'}.
			{#Ziel.
			#enum:.
			#(#Fluss #Mündung)}.
			{#Kilometer . #no: . 0}}
		full:
			{{#Bemerkung . #text: . ''}.
			{#FahrtArt.
			#enum:.
			#(#NormaleFahrt #Trainingsfahrt #Wanderfahrt)}}! !

!Fahrtenbuch class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:12'!
fahrtContext 
	"comment stating purpose of message"
	
	^GbtPlainAC struct: 'FahrtContext' define: {
		{#displayAs: . 'Fahrt'  } .
		{#uiSpec:icon: . #GbtItemUI . #rowingTeam}.
		{#chooseFor:from: . #Boot . Boote booteContext  }.
		{#chooseFor:use:from: . #Steuermann . self rudererDeclarative . Personen personenContext }.
		{#chooseFor:use:from: . #Mannschaft . self rudererDeclarative . Personen personenContext  }.
		}
! !

!Fahrtenbuch class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:12'!
fahrtenBuchContext 
	"comment stating purpose of message"
	
	^GbtBigListAC struct: 'FahrtenBuchContext' define: {
		{#displayAs: . 'FahrtenBuch'} .
		{#noPolicyPrefix: . 'Fahrt'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #rowingTeam} .
		{#templates: . self fahrt} .
		{#filterBy: . #(Bootsname RudererName) } .						
		{#loadPolicy: . #autoload } .
		{#display: . #( #(Bootsname Boot) #(RudererName Steuermann) Abfahrt)} .
		{#subcontext: . self fahrtContext }
		}
! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 3/20/2017 18:05'!
nextBizID
	^GbtBizAppServer default nextIdOfContextNoPolicy: #FahrtenBuchContext! !

!Fahrtenbuch class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
ruderer
	"self ruderer edit"
	
	^GbtThing struct: 'Ruderer' define: {
		{ #summary . '#RudererName , #RudererVorname' }.
		{ #purposes . #(Steuermann Ruderer) }.
		{ #RudererName . #val: . ''}.
		{ #RudererVorname . #val: .  ''}.
		{ #SportlerId . #val: .  ''}.
	} full: { 
		{ #FremdVerein. #val: . ''}.					
	}! !

!Fahrtenbuch class methodsFor: 'declaratives' stamp: 'hk 3/14/2017 13:01'!
rudererDeclarative
	^GbtDeclarative struct: 'RudererDeclarative' define: { 
		{ #RudererName . #tag: . #Nachname }.
		{ #RudererVorname . #tag: . #Vorname }.
		{ #SportlerId . #tag: .  #bizId}.
		{ #FremdVerein }.					
	} ! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 4/28/2017 11:04'!
storeTestFahrten
	GbtBizAppServer default contextNoPolicyOf: #FahrtenBuchContext prefix: #Fahrt.
	self testFahrt1 storeAll.
	self testFahrt2 storeAll.
	self testFahrt3 storeAll.
	self testFahrt4 storeAll.
	self testFahrt5 storeAll.
	self testFahrt6 storeAll! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 11/30/2016 14:06'!
testFahrt1
	^Fahrtenbuch fahrt 
		bizId: self nextBizID;
		Bootsname: #Alster;
		Steuermann: self testRuderer1;
		Kilometer: 20;
		yourself
! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 11/30/2016 14:06'!
testFahrt2
	^Fahrtenbuch fahrt 
		bizId: self nextBizID;
		Bootsname: #Alster;
		Steuermann: self testRuderer2;
		Kilometer: 28;
		yourself
! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 11/30/2016 14:06'!
testFahrt3
	^Fahrtenbuch fahrt 
		bizId: self nextBizID;
		Bootsname: #Alster;
		Steuermann: self testRuderer3;
		Kilometer: 30;
		yourself
! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 11/30/2016 14:06'!
testFahrt4
	| aFahrt |
	aFahrt := Fahrtenbuch fahrt 
		bizId: self nextBizID;
		Bootsname: #Elbe;
		Steuermann: self testRuderer3;
		Kilometer: 99;
		yourself.
	aFahrt Mannschaft newEntry: self testRuderer1 .
	^aFahrt

! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 11/30/2016 14:07'!
testFahrt5
	| aFahrt |
	aFahrt := Fahrtenbuch fahrt 
		bizId: self nextBizID;
		Bootsname: #Elbe;
		Steuermann: self testRuderer3;
		Kilometer: 77;
		yourself.
	aFahrt Mannschaft newEntry: self testRuderer2.
	^aFahrt
! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 11/30/2016 14:07'!
testFahrt6
	| aFahrt |
	aFahrt := Fahrtenbuch fahrt 
		bizId: self nextBizID;
		Bootsname: #Elbe;
		Steuermann: self testRuderer3;
		Kilometer: 66;
		yourself.
	aFahrt Mannschaft newEntry: self testRuderer3.
	^aFahrt 

! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 11/29/2016 15:16'!
testRuderer1
	^Fahrtenbuch ruderer
		RudererName: #Schmidt1;
		RudererVorname: #Henning;
		yourself! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 11/29/2016 15:16'!
testRuderer2
	^Fahrtenbuch ruderer
		RudererName: #Schmidt2;
		RudererVorname: #Henning;
		yourself! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 11/29/2016 15:17'!
testRuderer3
	^Fahrtenbuch ruderer
		RudererName: #Schmidt3;
		RudererVorname: #Henning;
		yourself! !

Object subclass: #Finanzen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

Finanzen subclass: #Beitragsabrechnung
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Beitragsabrechnung class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
abrechnungszeitraum
	"self abrechnungszeitraum edit"
	
	^GbtThing struct: 'Abrechnungszeitraum' define: {
		{ #summary . 'system template' }.
		{ #Von . #date: . Date current}.
		{ #bis . #date: . Date current}.	
	} full: { 
	}! !

!Beitragsabrechnung class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
beitrag
	^ GbtThing
		struct: 'Beitrag'
		define:
			{{#summary . '#Nachname #Vorname EUR #Betrag'}.
			{#Berechnungsdatum.
			#date:.
			Date current}.
			{#Nachname . #val: . ''}.
			{#Vorname . #val: . ''}.
			{#Mitgliedsnummer . #val: . ''}.
			{#FamilienOberhaupt.
			#enum:.
			#(false true)}.
			{#Mitgliedstatus.
			#enum:.
			#(#aktiv #passiv)}.
			{#Beitragstatus.
			#enum:.
			#(#Erwachsener 'Nichtverdiener14plus' 'Kind14minus')}.
			{#Familienname . #val: . ''}.
			{#FamilienmitgliedNr . #no: . 1}.
			{#normalBeitrag . #no: . 0}.
			{#Familienrabatt . #no: . 0}.
			{#Mindestbeitrag . #no: . 0}.
			{#ermBeitrag . #no: . 0}.
			{#beitrag . #no: . 0}.
			{#Betrag . #no: . 0}.
			{#Währung . #val: . 'EUR'}.
			{#vz . #val: . ''}.
			{#rz . #val: . ''}.
			{#az . #no: . 1}.
			{#Rechnungserzeugung.
			#enum:.
			#(false true)}.
			{#Fälligkeit.
			#date:.
			Date current}}! !

!Beitragsabrechnung class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:07'!
beitragContext 
	"self beitragContext edit"

	^GbtPlainAC struct: 'BeitragContext' define: {
		{#displayAs: . 'Beitrag'  } .
		{#uiSpec:icon: . #GbtItemUI . #beitragsMgmt16}
		}
! !

!Beitragsabrechnung class methodsFor: 'declaratives' stamp: 'hk 3/14/2017 13:01'!
beitragDecl
	^ GbtDeclarative
		struct: 'Beitrag'
		define:
			{{#Berechnungsdatum}.
			{#Nachname}.
			{#Vorname}.
			{#Mitgliedsnummer . #tag: . #bizId}.
			{#FamilienOberhaupt}.
			{#Mitgliedstatus}.
			{#Beitragstatus}.
			{#Familienname}.
			{#FamilienNummer}.
			{#FamilienmitgliedNr}.
			{#aktiv}.
			{#passiv}.
			{#Familienrabatt}.
			{#Mindestbeitrag}.
			{#normalBeitrag}.
			{#ermBeitrag}.
			{#beitrag}.
			{#Betrag}.
			{#Währung}.
			{#vz . #tag: . #vollzahler}.
			{#rz . #tag: . #rabattiert}.
			{#az . #tag: . #anzahl}.
			{#Rechnungserzeugung}.
			{#Fälligkeit}}! !

!Beitragsabrechnung class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
beitragsabrechnung
	^ GbtThing
		struct: 'Beitragsabrechnung'
		define:
			{{#summary . '#Abrechnungsname #BeitragssummeGesamt'}.
			{#idNumberPolicy . #BeitragsAbrechnungsNoPolicy}.
			{#Abrechnungsgenauigkeit.
			#enum:.
			#(#Tag #Monat #Halbjahr #Jahr)}.
			{#Abrechnungsname . #val: . ''}.
			{#Abrechnungszeitraum.
			#thing:.
			self abrechnungszeitraum}.
			{#Beitragstabelle.
			#thing:.
			Beitragstabellen beitragstabelle}.
			{#Abrechner . #val: . ''}.
			{#Beitragsliste.
			#listOf:.
			self beitrag}.
			{#BeitragssummeGesamt . #calc: . 'sum #beitrag'}.
			{#AnzahlVollzahler . #calc: . 'sum #vz'}.
			{#AnzahlRabattierteMitglieder . #calc: . 'sum #rz'}.
			{#AnzahlMitglieder . #calc: . 'sum #az'}}! !

!Beitragsabrechnung class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:08'!
beitragsabrechnungContext 

	self beitragDecl.	"stellt das Declarative HKBeitrag bereit"

	^GbtPlainAC struct: 'BeitragsabrechnungContext' define: {
		{#displayAs: . 'Beitragsabrechnung'} .
		{#uiSpec:icon: . #GbtItemWithTabsUI . #beitragsMgmt16} .
		{#aspect:on: . self beitragslisteContext  . #Beitragsliste } .
		{#menu:items: . #BeitraegsMenu . #('Beitragsabrechnungen erstellen' 'Einbuchen') }.
		{#behavior:actions: . #'Beitragsabrechnungen erstellen' . 
			#(MAPBL PersonenContext 
			 READSLOT #(Beitragstabelle vBTab)  
			 ALTER #( vBTab Beitrag ) 
			 FREEZE list  
			 REDUCE #(contextVO Beitragsliste) )}
	}! !

!Beitragsabrechnung class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:08'!
beitragsabrechnungenContext 
	"comment stating purpose of message"
	
	^GbtBigListAC struct: 'BeitragsabrechungenContext' define: {
		{#displayAs: . 'Beitragsabrechnungen'} .
		{#noPolicyPrefix: . 'Abrechnung_'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #beitragsMgmt16} .
		{#templates: . self beitragsabrechnung} .
		{#loadPolicy: . #autoload }.
		{#chooseFor: . #Beitragstabelle }.
		{#chooseWith: . Beitragstabellen beitragstabellenContext}.
		{#display: . #( #(BeitragssummeGesamt Summe) #(AnzahlMitglieder Mitglieder) #(AnzahlVollzahler Vollzahler) #(AnzahlRabattierteMitglieder #rabattiert) )}.
		{#subcontext: . self beitragsabrechnungContext }
		}
! !

!Beitragsabrechnung class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:09'!
beitragslisteContext 
	"comment stating purpose of message"
	
	^GbtUlistAC struct: 'BeitragslisteContext' define: {
		{#displayAs: . 'Beitragsliste'  } .
		{#uiSpec:icon: . #GbtListAndItemUI . #beitragsMgmt16}.
		{#template:for: . self beitrag . #Beitragsliste} .
		{#display: . #(Nachname Vorname Betrag)} .
		{#subcontext: . self beitragContext }
		}! !

Finanzen subclass: #Beitragsmanagement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Beitragsmanagement class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
beitragsmanagement
	^ GbtThing
		struct: 'Beitragsmanagment'
		define:
			{{#AktuellerAbrechnungszeitraum . #val: . ''}.
			{#OffeneBeiträge . #no: . 0}.
			{#Beitragstabellen.
			#thing:.
			Beitragstabellen beitragstabelle}.
			{#Beitragsabrechnungen.
			#thing:.
			Beitragsabrechnung beitragsabrechnung}.
			{#Rechnungen.
			#thing:.
			Rechnungen rechnung}}
		full: {}! !

!Beitragsmanagement class methodsFor: 'test data' stamp: 'hk 4/28/2017 11:04'!
beitragsmanagement01
	"self beitragsmanagement01 edit"
	^(self beitragsmanagement01: self beitragsmanagement) storeAll
! !

!Beitragsmanagement class methodsFor: 'test data' stamp: 'CC 8/12/2016 18:50'!
beitragsmanagement01: b
	"self beitragsmanagement01 edit"
	
	b Beitragstabellen: Beitragstabellen beitragsTabelle2016.
	^b! !

!Beitragsmanagement class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:09'!
beitragsmanagementContext 
	"comment stating purpose of message"
	
	^GbtPlainAC struct: 'BeitragsmanagementContext' define: {
		{#displayAs: . 'Beitragsmanagment'} .
		{#uiSpec:icon: . #GbtItemWithTabsUI . #beitragsMgmt16} .
		{#vo: . self beitragsmanagement} .
		{#loadPolicy: . #autoload } .
		{#aspect:on: . Beitragstabellen beitragstabellenContext . #Beitragstabellen } .
		{#aspect:on: . Beitragsabrechnung beitragsabrechnungenContext . #Beitragsabrechnungen } .
		{#aspect:on: . Rechnungen rechnungenContext . #Rechnungen } .
"		{#aspect:on: . OPListen opListenContext . #opListen } "
		{#menu:items: . #Beitragsmanagement . #(#'Do Something 1' #'Do Something 2') }.
		}
! !

!Beitragsmanagement class methodsFor: 'examples' stamp: 'hk 3/22/2017 17:46'!
exampleRun
	| ui app|
	GbtBizAppServer initialize. 
	GbtSVO initialize.
	self beitragsmanagementContext.
	app := GbtBizAppServer default mainContext.
	ui := app ui.
	ui title: ('Beitragsmanagement', ui title).
	ui open! !

Finanzen subclass: #Beitragstabellen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Beitragstabellen class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
basisBeitragAktiv
	"self HKbasisBeitragAktiv edit"
	
	^GbtThing struct: 'BasisBeitragAktiv' define: {
		{ #summary . 'system template' }.
		{ #Erwachsener . #no: . 230 }.
		{ #Nichtverdiener14plus . #no: . 135}.
		{ #Kind14minus . #no: . 100}.
	}! !

!Beitragstabellen class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
basisBeitragPassiv
	"self BasisBeitragPassiv edit"
	
	^GbtThing struct: 'BasisBeitragPassiv' define: {
		{ #summary . 'system template' }.
		{ #Erwachsener . #no: . 115 }.
		{ #Nichtverdiener14plus . #no: . 115}.
		{ #Kind14minus . #no: . 115}.
	}! !

!Beitragstabellen class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
beitragXLS
	^ GbtThing
		struct: 'BeitragXLS'
		define:
			{{#summary . 'system template'}.
			{#aktiv.
			#thing:tag:.
			self basisBeitragAktiv.
			#aktiv}.
			{#passiv.
			#thing:tag:.
			self basisBeitragPassiv.
			#passiv}.
			{#Währung . #val: . #EUR}.
			{#Mindestbeitrag . #no: . 70.0}.
			{#Familienrabatt . #no: . 0.5}.
			{#normalBeitrag . #calc: . 'lookup #Mitgliedstatus #Beitragstatus'}.
			{#ermBeitrag . #calc: . '( #FamilienmitgliedNr asNumber = 2) ifTrue: [ #normalBeitrag asNumber* #Familienrabatt asNumber ] ifFalse: [ #Mindestbeitrag ] '}.
			{#beitrag . #calc: . '( #FamilienOberhaupt = ''true'') ifTrue:[ #normalBeitrag ] ifFalse:[ #ermBeitrag ]'}.
			{#Betrag . #calc: . ' #beitrag asNumber max: ( #Mindestbeitrag asNumber)'}.
			{#vollzahler . #calc: . '( #Betrag = #normalBeitrag ) ifTrue:[1]ifFalse:[0]'}.
			{#rabattiert . #calc: . '( #Betrag = #normalBeitrag ) ifTrue:[0]ifFalse:[1]'}.
			{#anzahl . #no: . 1}}! !

!Beitragstabellen class methodsFor: 'test data' stamp: 'hk 8/18/2016 16:23'!
beitragsTabelle2016
	^self beitragsTabelle2016: self beitragstabelle! !

!Beitragstabellen class methodsFor: 'test data' stamp: 'hk 11/15/2016 16:22'!
beitragsTabelle2016: t
	"self beitragsTabelle2016 editD"
	
	^t TabellenName: #Jahr_2016 ;
		GueltigkeitVon: '01.01.2016' ;
		GueltigkeitBis: '12.31.2016';
		Mindestbeitrag: 70.00 ;		
		Familienrabatt: 0.5;		
		BeschlossenAm: '03.02.2016';	
		Abrechnungsmodus: #GanzjahresAbrechnung	;
		yourself
! !

!Beitragstabellen class methodsFor: 'test data' stamp: 'hk 8/18/2016 16:28'!
beitragsTabelle2016HJ1
	^self beitragsTabelle2016HJ1: self beitragstabelle! !

!Beitragstabellen class methodsFor: 'test data' stamp: 'hk 11/15/2016 16:22'!
beitragsTabelle2016HJ1: t
	"self beitragsTabelle2016HJ1 editD"
	
	^t TabellenName: #'1.HJ_2016' ;
		GueltigkeitVon: '01.01.2016' ;
		GueltigkeitBis: '06.30.2016';
		Mindestbeitrag: 70.00 ;		
		Familienrabatt: 0.5;		
		BeschlossenAm: '03.02.2016';		
		yourself
! !

!Beitragstabellen class methodsFor: 'test data' stamp: 'hk 8/18/2016 16:28'!
beitragsTabelle2016HJ2
	^self beitragsTabelle2016HJ2: self beitragstabelle! !

!Beitragstabellen class methodsFor: 'test data' stamp: 'hk 11/15/2016 16:22'!
beitragsTabelle2016HJ2: t
	"self beitragsTabelle2016HJ1 editD"
	
	^t TabellenName: #'2.HJ_2016' ;
		GueltigkeitVon: '07.01.2016' ;
		GueltigkeitBis: '12.31.2016';
		Mindestbeitrag: 80.00 ;		
		Familienrabatt: 0.4;		
		BeschlossenAm: '03.02.2016';		
		yourself
! !

!Beitragstabellen class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
beitragstabelle
	^ GbtThing struct: 'HKBeitragstabelle' define: {
			{#summary . '#TabellenName : #GueltigkeitVon - #GueltigkeitBis '}.
			{#idNumberPolicy . #BeitragsTabelleNoPolicy}.
			{#TabellenName . #val: . ''}.
			{#GueltigkeitVon.  #date:. Date current}.
			{#GueltigkeitBis . #date:. Date current}.
			{#Abrechnungsmodus . #enum:. #(#HalbjahresAbrechnung #GanzjahresAbrechnung)}.
			{#BeitragXLS . #thing:. self beitragXLS}.
			{#BeschlossenAm . #date: . Date current}.
			{#BeschlossenDurch . #enum: . #(#Hauptversammlung #Sonderregelung)}}! !

!Beitragstabellen class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:10'!
beitragstabelleContext 
	""
	^GbtPlainAC struct: 'BeitragstabelleContext' define: {
		{#displayAs: . 'Beitragstabelle'} .
		{#uiSpec:icon: . #GbtItemUI . #beitragsMgmt16} .
		}
! !

!Beitragstabellen class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:10'!
beitragstabellenContext
	^ GbtBigListAC struct: 'BeitragstabellenContext' define: {
			{#displayAs: . 'Beitragstabellen'}.
			{#noPolicyPrefix: . 'BT'}.
			{#uiSpec:icon: . #GbtListAndItemUI . #bizoffer16}.
			{#templates: . self beitragstabelle}.
			{#loadPolicy: . #autoload}.
			{#display: . #(#(#TabellenName #Name) #(#GueltigkeitVon #von) #(#GueltigkeitBis #bis))}.
			{#subcontext: . self beitragstabelleContext}}! !

!Beitragstabellen class methodsFor: 'test data' stamp: 'hk 4/28/2017 11:04'!
beitragstabellenliste1
	self beitragsTabelle2016 storeAll.
	self beitragsTabelle2016HJ1 storeAll.
	self beitragsTabelle2016HJ2 storeAll.! !

!Beitragstabellen class methodsFor: 'contexts' stamp: 'hk 3/22/2017 17:41'!
exampleRun
	| ui |
	GbtBizAppServer initialize. GbtSVO initialize.
	(ui := (self beitragstabellenContext) ui) title: ('Beitragstabellen', ui title); open! !

Finanzen subclass: #OPListen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!OPListen class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
opListe
	^ GbtThing
		struct: 'opListe'
		define:
			{{#summary . '#bizId #Berechnungsdatum EUR #Beitragshöhe'}.
			{#idNumberPolicy . #OPListeNoPolicy}.
			{#Bezeichnung . #val: . ''}.
			{#Erstellung.
			#enum:.
			#(#Rechnung #Storno)}.
			{#OPListeAktuell.
			#listOf:.
			Rechnungen rechnung}.
			{#OPSumme . #no: . 0}}
		full: {}! !

!OPListen class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:23'!
opListeContext 
	""
	^GbtPlainAC struct: 'opListeContext' define: {
		{#displayAs: . 'OPListe'} .
		{#uiSpec:icon: . #GbtItemUI . #beitragsMgmt16} .
		{#behavior:actions: . #'Mahnungen verschicken' . 
			#(HALT void )}
		}
! !

!OPListen class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:23'!
opListenContext 
	""
	^GbtBigListAC struct: 'opListenContext' define: {
		{#displayAs: . 'OPListen'} .
		{#uiSpec:icon: . #GbtListAndItemUI . #bizoffer16} .
		{#templates: . self opListe} .
		{#loadPolicy: . #autoload } .
		{#display: . #( #(bizId Rechnungsnummer) #(Rechnungsbeitrag Beitrag) )} .
		{#subcontext: . self opListeContext}
		}
! !

Finanzen subclass: #Rechnungen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Rechnungen class methodsFor: 'examples' stamp: 'hk 3/22/2017 17:41'!
exampleRun
	| ui |
	GbtBizAppServer initialize. GbtSVO initialize.
	(ui := (self rechnungenContext) ui) title: ('Beitragsrechnungen', ui title); open! !

!Rechnungen class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
familienConstraint
	"self familienConstraint editD"
	^GbtThing struct: 'FamilienConstraint' define: { 
		{ #mitglied . #constraint: . '#FamilienmitgliedNr asNumber >1'}.
		{ #familie  . #constraint: . '#FamilienNummer = #AdressatNummer'} }! !

!Rechnungen class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
oberhauptConstraint
	"self oberhauptConstraint editD"
	^GbtThing struct: 'OberhauptConstraint' define: { 
		{ #mitglied . #constraint: . '#FamilienmitgliedNr asNumber = 1'} }! !

!Rechnungen class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
rechnung
	^ GbtThing
		struct: 'Rechnung'
		define:
			{{#summary . '#bizId #Berechnungsdatum EUR #Beitragshöhe'}.
			{#idNumberPolicy . #RechnungNoPolicy}.
			{#Rechnungstyp.
			#enum:.
			#(#Rechnung #Storno)}.
			{#Rechnungsdatum.
			#date:.
			Date current}.
			{#Rechnungskopf . #val: . 'Absender aus Vereinsstammdaten'}.
			{#Rechnungsadresse.
			#thing:.
			self rechnungsadresse}.
			{#Rechnungspositionen.
			#listOf:.
			self rechnungsposition}.
			{#Rechnungsbeitrag . #calc: . 'sum #Betrag'}}
		full:
			{{#Eingebucht.
			#enum:.
			#(false true)}.
			{#Buchungsdatum.
			#date:.
			Date current}.
			{#Fälligkeit.
			#date:.
			Date current}}! !

!Rechnungen class methodsFor: 'declaratives' stamp: 'hk 3/14/2017 13:01'!
rechnungBeitragDeclarative
	^ GbtDeclarative
		struct: 'RechnungBeitragDecl'
		define:
			{{#Berechnungsdatum}.
			{#Nachname}.
			{#Vorname}.
			{#Mitgliedsnummer}.
			{#Familienname}.
			{#FamilienNummer}.
			{#FamilienmitgliedNr}.
			{#Betrag}.
			{#Währung}.
			{#AdressatNummer}}! !

!Rechnungen class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:24'!
rechnungContext
	self familienConstraint; rechnungBeitragDeclarative.
	^ GbtPlainAC struct: 'RechnungContext' define:
			{{#displayAs: . 'Rechnung'}.
			{#uiSpec:icon: . #GbtItemUI . #beitragsMgmt16}.
			{#behavior:arguments:actions:. #positionen. #(#v0).
				#(#NEWVO #void 
				  #READSLOT #(#Mitgliedsnummer #v2) 
				  #WRITESLOT #(#v2 #AdressatNummer) 
				  #TRANSFORM #(#thing #Rechnungsposition #v1) 
				  #ADD2L #(#v1 #Rechnungspositionen) 
				  #ASSIGN #(#contextVO #thing) 
				  #ASSIGN #(#thing #vRg) 
				  #MAP #(#v0 #Beitragsliste) 
				  #ALTER #(#vRg #RechnungBeitragDecl) 
				  #FILTER #FamilienConstraint 
				  #ALTER #(#void #Rechnungsposition) 
				  #REDADD #(#thing #Rechnungspositionen))}}! !

!Rechnungen class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:24'!
rechnungenContext
	self rechnungspositionDeclarative; oberhauptConstraint.
	^ GbtBigListAC struct: 'RechnungenContext' define:
			{{#displayAs: . 'Rechnungen'}.
			{#noPolicyPrefix: . 'Rng'}.
			{#uiSpec:icon: . #GbtListAndItemUI . #bizoffer16}.
			{#templates:. self rechnung}.
			{#loadPolicy: . #autoload}.
			{#display:. #(#(#AdressatNummer #Mitgliedsnummer) #(#Rechnungsbeitrag #Beitrag))}.
			{#subcontext:. self rechnungContext}.
			{#menu: . #Rechnungslauf}.
			{#menu: . #'Neue Rechnung'}.
			{#behavior:actions:. #Rechnungslauf.
				#(#ASKELEM #(#BeitragsabrechungenContext #v1) 
				  #MAP #(#v1 #Beitragsliste) 
				  #FILTER #OberhauptConstraint 
				  #APPLY #(#RechnungContext #positionen #v1) 
				  #REFRESH #gui)}.
			{#behavior:actions:. #'Neue Rechnung'.
				#(#ASKELEM #(#BeitragsabrechungenContext #v1) 
				  #ASSIGN #(#v1 #thing) 
				  #ASKFROM #(#Beitragsliste #thing) 
				  #BEHAVIOR #(#RechnungContext #positionen #v1) 
				  #REFRESH #gui)}}! !

!Rechnungen class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
rechnungsadresse
	^ GbtThing
		struct: 'Rechnungsadresse'
		define:
			{{#summary . 'system template'}.
			{#AdressatNummer . #val: . 'bizId'}.
			{#AdressatName . #val: . ''}.
			{#AdressatVorname . #val: . ''}.
			{#StraßeUndNummer . #val: . ''}.
			{#PLZUndWohnort . #val: . ''}}! !

!Rechnungen class methodsFor: 'declaratives' stamp: 'hk 3/14/2017 13:01'!
rechnungsadresseDeclarative
	^ GbtDeclarative
		struct: 'Rechnungsadresse'
		define:
			{{#AdressatName . #tag: . #Nachame}.
			{#AdressatVorname . #tag: . #Vorname}.
			{#StraßeUndNummer}.
			{#PLZUndWohnort}}! !

!Rechnungen class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
rechnungsposition
	^ GbtThing
		struct: 'Rechnungsposition'
		define:
			{{#summary . '#Betrag #Währung : #Nachname #Vorname '}.
			{#Nachname . #val: . ''}.
			{#Vorname . #val: . ''}.
			{#Mitgliedsnummer . #val: . ''}.
			{#AbrechnungVon.
			#date:.
			Date current}.
			{#AbrechnungBis.
			#date:.
			Date current}.
			{#Betrag . #no: . 0}.
			{#Währung . #val: . 'EUR'}.
			{#AbrechnungVon.
			#date:.
			Date current}}! !

!Rechnungen class methodsFor: 'declaratives' stamp: 'hk 3/14/2017 13:01'!
rechnungspositionDeclarative
	^ GbtDeclarative
		struct: 'Rechnungsposition'
		define:
			{{#summary . '#Nachname , #Vorname : #Betrag #Währung'}.
			{#Nachname}.
			{#Vorname}.
			{#Mitgliedsnummer}.
			{#AbrechnungVon}.
			{#AbrechnungBis}.
			{#Betrag}.
			{#Währung}.
			{#AbrechnungVon . #tag: . #Berechnungsdatum}}! !

Object subclass: #Kommunikation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

Object subclass: #Stammdaten
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

Stammdaten subclass: #Boote
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Boote class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
boot
	^ GbtThing
		struct: 'Boot'
		define:
			{{#summary . '#bizId : #Bootsname'}.
			{#idNumberPolicy . #BootNoPolicy}.
			{#Bootstyp.
			#enum:.
			#(#Einer #Zweier #Dreier #Vierer #Fünfer #Achter)}.
			{#Bootsname . #val: . ''}.
			{#MannschaftAnzahlMax . #no: . 1}}
		full:
			{{#Steuermann.
			#enum:.
			#(#mit #ohne)}.
			{#Baujahr . #val: . ''}}! !

!Boote class methodsFor: 'testData' stamp: 'hk 11/30/2016 13:45'!
boot01
	"self boot01 edit"
	^self boot
		bizId: self nextBizID;
		Bootsname: 'Wisch' ;	
		Bootstyp: #Einer;
		MannschaftAnzahlMax: 1;	
		Steuermann: #ohne;
		Baujahr: 2001;
		yourself

! !

!Boote class methodsFor: 'testData' stamp: 'hk 11/30/2016 13:45'!
boot02
	"self boot02 edit"
	^self boot
		bizId: self nextBizID;
		Bootsname: 'Alster' ;	
		Bootstyp: #Zweier;
		MannschaftAnzahlMax: 3;	
		Steuermann: #mit;
		Baujahr: 1964;
		yourself

! !

!Boote class methodsFor: 'testData' stamp: 'hk 11/30/2016 13:45'!
boot03
	"self boot03 edit"
	^self boot
		bizId: self nextBizID;
		Bootsname: 'Elbe' ;	
		Bootstyp: #Zweier;
		MannschaftAnzahlMax: 2;	
		Steuermann: #ohne;
		Baujahr: 1980;
		yourself

! !

!Boote class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:10'!
bootContext 
	"comment stating purpose of message"
	
	^GbtPlainAC struct: 'BootContext' define: {
		{#displayAs: . 'Boot'  } .
		{#uiSpec:icon: . #GbtItemUI . #rowingBoat}
		}
! !

!Boote class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:11'!
booteContext 
	""
	^GbtBigListAC struct: 'BooteContext' define: {
		{#displayAs: . 'Boote'} .
		{#noPolicyPrefix: . 'Boot'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #rowingBoat} .
		{#templates: . self boot} .
		{#loadPolicy: . #autoload } .
		{#display: . #( #(Bootsname Boot) #(Bootstyp Typ) #(Steuermann Steuermann))} .
		{#subcontext: . self bootContext }
		}

! !

!Boote class methodsFor: 'testData' stamp: 'hk 4/28/2017 11:04'!
booteListe1
	GbtBizAppServer default contextNoPolicyOf: #BooteContext prefix: #Boot.
	self boot01 storeAll.
	self boot02 storeAll.
	self boot03 storeAll! !

!Boote class methodsFor: 'example' stamp: 'hk 3/22/2017 17:40'!
exampleRun
	GbtBizAppServer initialize. GbtSVO initialize.
	(self booteContext) ui title: #Boote; open! !

!Boote class methodsFor: 'testData' stamp: 'hk 3/20/2017 18:05'!
nextBizID
	^GbtBizAppServer default nextIdOfContextNoPolicy: #BooteContext! !

Stammdaten subclass: #FahrtenabzeichenStammdaten
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

Stammdaten subclass: #Personen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Personen class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
eMail
	"self eMail edit"
	
	^GbtThing struct: 'EMail' define: {
		{ #purposes .   #(Privat Arbeit)}.
		{ #summary .  '#EMail'}.
		{ #EMail . #val: . 'EMail'}.	
 	} full: {  
	}! !

!Personen class methodsFor: 'examples' stamp: 'hk 3/22/2017 17:41'!
exampleRun
	| ui |
	GbtBizAppServer initialize. GbtSVO initialize.
	(ui := (self personenContext) ui) title: ('Sportler und Mitglieder', ui title); open! !

!Personen class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
kontaktdaten
	^ GbtThing
		struct: 'Kontaktdaten'
		define: {{#summary . 'EMail: #EMail Tel: #telNo'}}
		full:
			{{#StraßeUndNummer . #val: . ''}.
			{#PLZUndWohnort . #val: . ''}.
			{#Kommunikation.
			#listOf:.
			{self telNo.
			self eMail}}}! !

!Personen class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
kontoDaten
	"self kontoDaten edit"
	
	^GbtThing struct: 'KontoDaten' define: {
		{ #summary .  '#Kontoinhaber'}.	
	} full: { 
		{ #Kontoinhaber . #calc: . '#Vorname #Nachname' }.
		{ #IBAN . #val: .  ''}.
		{ #BIC . #val: . ''}.
	}! !

!Personen class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
mitglied
	^ GbtThing
		struct: 'Mitglied'
		define:
			{{#summary . '#bizId : #Mitgliedstatus #Beitragstatus'}.
			{#idNumberPolicy . #MitgliedNoPolicy}.
			{#GebDatum.
			#date:.
			Date current}.
			{#Mitgliedstatus.
			#enum:.
			#(#aktiv #passiv)}.
			{#Beitragstatus.
			#enum:.
			#(#Erwachsener 'Nichtverdiener14+' 'Kind14-')}.
			{#FamilienOberhaupt.
			#enum:.
			#(false true)}.
			{#FamilienmitgliedNr . #no: . 1}.
			{#MitgliedSeit.
			#date:.
			Date current}}
		full:
			{{#Beruf . #val: . ''}.
			{#Familienname . #val: . ''}.
			{#FamilienNummer . #val: . 'bizId Oberhaupt'}.
			{#Familienmitglieder.
			#enum:.
			#()}.
			{#FahrtenabzeichenStatus.
			#enum:.
			#('M18max' 'W18max' 'M18plus' 'W18plus')}.
			{#Schnuppermitglied.
			#enum:.
			#(false true)}.
			{#Austrittserklärung.
			#date:.
			Date current}.
			{#Austritt . #calc: . '(( #Austrittserklärung  = ''nil'') not ) ifTrue: [ ( #Schnuppermitglied asString = ''true'') ifTrue: [ #MitgliedSeit asDate addMonths: 3 ] ifFalse: [ Date year: (Date current year) month: 12 day: 31 ]]'}.
			{#KontoDaten.
			#thing:.
			self kontoDaten}.
			{#Beitragsrechnung.
			#listOf:.
			Rechnungen rechnung}.
			{#BeitragsSonderregelung.
			#enum:.
			#(false true)}.
			{#Abrechnungsperiode.
			#enum:.
			#(#jährlich #halbjährlich #monatlich #sonstiges)}}! !

!Personen class methodsFor: 'test data' stamp: 'hk 3/20/2017 18:16'!
nextBizID
	^GbtBizAppServer default nextIdOfContextNoPolicy: #PersonenContext
! !

!Personen class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
person
	"self person edit"
	
	^GbtThing struct: 'Person' define: {
		{ #summary .  '#bizId : #Vorname #Nachname'}.	
		{ #idNumberPolicy . #SportlerNoPolicy }.
		{ #Nachname . #val: . ''}.
		{ #Vorname . #val: .  ''}.
		{ #Vorname2 . #val: . ''}.	
		} full: { 
		{ #Kontaktdaten . #thing: . self kontaktdaten }.	
		{ #Sportler . #thing: . self sportlerdaten}.	
		{ #mitglied . #thing: . self mitglied}.		
	}! !

!Personen class methodsFor: 'test data' stamp: 'hk 11/29/2016 16:39'!
person01
	"self person01 editD"

	| m p |
	p := self person .
	m := p mitglied.
	m GebDatum: '08.06.1954' .	
	m Mitgliedstatus: #aktiv .	
	m Beitragstatus: #Erwachsener .	
	m FamilienOberhaupt: #true.	
	m FamilienmitgliedNr: 1.	
	m MitgliedSeit: '01.01.1967'.
	m Familienname: #Schmidt .
	m BeitragsSonderregelung: #false .
	m Abrechnungsperiode: #jährlich.	
	m Beruf:'Kaufmann'.
	m Familienname: 'Schmidt'.
	m KontoDaten IBAN: 'DE1234567890'.
	m KontoDaten BIC:'XYZABC'.
	m Abrechnungsperiode: #jährlich.
	
	p Nachname: #Schmidt .
	p Vorname: #Henning.
	p Kontaktdaten StraßeUndNummer: 'Rethfelder Str 48'.
	p Kontaktdaten PLZUndWohnort: '25336 Elmshorn'.
	(p Kommunikation) newEntry: ( self telNo TelNr: '04121 48839'; yourself)  with: 'Privat'.
	p Kommunikation newEntry: (self eMail EMail:'schmidt@gmail.com'; yourself) with: 'Privat'.
	
	^p
! !

!Personen class methodsFor: 'test data' stamp: 'hk 11/30/2016 18:02'!
person02
	"self person02  editD"

	| m  p |
	p := self person .
	m := p mitglied.
	m GebDatum: '10.07.1961' .	
	m Mitgliedstatus: #aktiv .	
	m Beitragstatus: #Erwachsener .	
	m FamilienOberhaupt: #false.	
	m FamilienmitgliedNr: 2.	
	m MitgliedSeit: '01.15.1993'.
	m Familienname: #Schmidt .
	m BeitragsSonderregelung: #false .
	m Abrechnungsperiode: #jährlich.	
	m Beruf:'Buchhändlerin'.
	m Familienname: 'Schmidt'.
	m FamilienNummer: 'Sportler1'.
	m Abrechnungsperiode: #jährlich.
	
	p Nachname: #Schmidt .
	p Vorname: #Christel.
	p Kontaktdaten StraßeUndNummer: 'Rethfelder Str 48'.
	p Kontaktdaten PLZUndWohnort: '25336 Elmshorn'.
	(p Kommunikation) newEntry: ( self telNo TelNr: '04121 48839'; yourself)  with: 'Privat'.
	p Kommunikation newEntry: (self eMail EMail:'schmidt@gmail.com'; yourself) with: 'Privat'.
	
	^p
! !

!Personen class methodsFor: 'test data' stamp: 'hk 11/30/2016 18:02'!
person03
	"self person03 editD"

	| m  p |
	p := self person .
	m := p mitglied.
	m GebDatum: '03.10.1996' .	
	m Mitgliedstatus: #aktiv .	
	m Beitragstatus: #Nichtverdiener14plus .	
	m FamilienOberhaupt: #false.	
	m FamilienmitgliedNr: 3.	
	m MitgliedSeit: '01.01.2007'.
	m Familienname: #Schmidt .
	m BeitragsSonderregelung: #false .
	m Abrechnungsperiode: #jährlich.	
	m Beruf:'Schülerin'.
	m Familienname: 'Schmidt'.
	m FamilienNummer: 'Sportler1'.
	m Abrechnungsperiode: #jährlich.
	
	p Nachname: #Schmidt .
	p Vorname: #Imke.
	p Kontaktdaten StraßeUndNummer: 'Rethfelder Str 48'.
	p Kontaktdaten PLZUndWohnort: '25336 Elmshorn'.
	(p Kommunikation) newEntry: ( self telNo TelNr: '04121 48839'; yourself)  with: 'Privat'.
	p Kommunikation newEntry: (self eMail EMail:'schmidt@gmail.com'; yourself) with: 'Privat'.
	
	^p
! !

!Personen class methodsFor: 'test data' stamp: 'hk 11/30/2016 18:02'!
person04
	"self person04 editD"

	| m  p |
	p := self person .
	m := p mitglied.
	m GebDatum: '10.10.1989' .	
	m Mitgliedstatus: #passiv .	
	m Beitragstatus: #Erwachsener .	
	m FamilienOberhaupt: #false.	
	m FamilienmitgliedNr: 4.	
	m MitgliedSeit: '01.01.2000'.
	m Familienname: #Schmidt .
	m BeitragsSonderregelung: #false .
	m Abrechnungsperiode: #jährlich.	
	m Beruf:'Sozialpädagogin'.
	m Familienname: 'Schmidt'.
	m FamilienNummer: 'Sportler1'.
	m Abrechnungsperiode: #jährlich.
	
	p Nachname: #Schmidt .
	p Vorname: #Levke.
	p Kontaktdaten StraßeUndNummer: 'Rethfelder Str 48'.
	p Kontaktdaten PLZUndWohnort: '25336 Elmshorn'.
	(p Kommunikation) newEntry: ( self telNo TelNr: '04121 48839'; yourself)  with: 'Privat'.
	p Kommunikation newEntry: (self eMail EMail:'schmidt@gmail.com'; yourself) with: 'Privat'.
	
	^p
! !

!Personen class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:23'!
personContext 	
	^GbtPlainAC struct: 'PersonContext' define: {
		{#displayAs: . 'Person'  } .
		{#uiSpec:icon: . #GbtItemUI . #rower}.
		}! !

!Personen class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:23'!
personenContext 
	^GbtBigListAC struct: 'PersonenContext' define: {
		{#displayAs: . 'Personen'} .
		{#noPolicyPrefix: . 'Sportler'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #rower} .
		{#templates: . self person} .
"		{#loadPolicy: . #simpleload } ."
		{#loadPolicy: . #autoload } .
		{#display: . #( #(Nachname Name) #(Vorname Vorname))} .
		{#subcontext: . self personContext}
		}
! !

!Personen class methodsFor: 'test data' stamp: 'hk 4/28/2017 11:04'!
personenListe1
	| tmp1 |
	GbtBizAppServer default contextNoPolicyOf: #PersonenContext prefix: #Sportler.
	1 to: 10 do: [ :tmp2 | 
		tmp1 := self person01 bizId: self nextBizID.
		tmp1 Nachname: 'Schmidt' , tmp2 printString; storeAll ].
	1 to: 1 do: [ :tmp2 | 
		tmp1 := self person02 bizId: self nextBizID.
		tmp1 Nachname: 'Schmidt' , tmp2 printString; storeAll ].
	1 to: 1 do: [ :tmp2 | 
		tmp1 := self person03 bizId: self nextBizID.
		tmp1 Nachname: 'Schmidt' , tmp2 printString; storeAll ].
	1 to: 1 do: [ :tmp2 | 
		tmp1 := self person04 bizId: self nextBizID.
		tmp1 Nachname: 'Schmidt' , tmp2 printString; storeAll ]! !

!Personen class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
sportlerdaten
	"self sportlerdaten  edit"
	
	^GbtThing struct: 'Sportlerdaten' define: { 
		{ #summary . 'system template' }.
	} full: { 
		{ #Fremdverein . #val: . ''}.
		{ #Bemerkungen . #text: . ''}.
	}! !

!Personen class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
telNo
	"self telNo edit"
	
	^GbtThing struct: 'TelNo' define: {
		{ #purposes .   #(mobileprivat mobilarbeit Privat Arbeit Fax )}.
		{ #summary .  '#TelNr'}.
		{ #TelNr . #val: . 'Telefonnummer'}.	
 	} ! !

Object subclass: #Statistics
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Statistics class methodsFor: 'contexts' stamp: 'hk 9/30/2016 14:56'!
createGlobals
	self ergebnisDecl .
	self transformStatisticDecl.  
	self kmStatisticBoote .
	self kmStatisticRuderer .
! !

!Statistics class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
ergebnis
	"self ergebnis edit"
	^GbtThing struct: 'Ergebnis' define: {
		{ #summary . 'km-Statistik' }.
		{ #FahrtID . #val: . '' }.
		{ #Datum . #date: . Date today}.
		{ #Bootsname . #val: . '' }.
		{ #RudererName . #val: . '' }.
		{ #Kilometer . #val: . '' }.
		{ #Abfahrt . #date: . Date today}.
		{ #Ankunft . #date: . Date today}.
		{ #Ziel . #val: . '' }.
	}! !

!Statistics class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:24'!
ergebnisContext 
	^GbtPlainAC struct: 'ErgebnisContext' define: {
		{#displayAs: . 'Ergebnis'  } .
		{#uiSpec:icon: . #GbtItemUI . #statistics}}! !

!Statistics class methodsFor: 'declaratives' stamp: 'hk 3/14/2017 13:01'!
ergebnisDecl
	"Ergebnis-Declarative copies the fields from Fahrt"
	
	^GbtDeclarative struct: 'Ergebnis' define: {
		{ #FahrtID . #tag: . #bizId }.
		{ #Bootsname }.
		{ #RudererName }.
		{ #Kilometer }.
		{ #Abfahrt }.
		{ #Ankunft }.
		{ #Ziel }.
	}! !

!Statistics class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:24'!
ergebnisseContext 
	^GbtUlistAC struct: 'ErgebnisseContext' define: {
		{#displayAs: . 'Ergebnisse'  } .
		{#uiSpec:icon: . #GbtListAndItemUI . #statistics}.
		{#template:for: . self ergebnis . #resultList } .
		{#display: . #(FahrtID Datum Abfahrt Ankunft Ziel Bootsname RudererName Kilometer)} .
		{#subcontext: . self ergebnisContext}.
		}! !

!Statistics class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
fahrtenConstraint
	"self fahrtenConstraint editD"

	^GbtThing struct: 'FahrtenConstraint' define: { 
		{ #begin . #date: .  '1.1.2016' }.
		{ #end . #date: .  '12.31.2016' }.
		{ #gtBegin . #constraint: . '#Abfahrt asDate > #begin asDate'} .
		{ #ltEnd . #constraint: . '#Ankunft asDate < #end asDate'}.
		{ #boot . #val: .  ''}.
		{ #welches . #constraint: . '#Bootsname = #boot'}.
		{ #ruderer . #val: .  ''}.
		{ #fahrtenBesatzung . #calc: . 'ref #Besatzung'}.
		{ #wer . #constraint: . '(GbtThing definedAs: #fahrtenBesatzung ) contains: #ruderer at: ''RudererName'''}.
	}.
! !

!Statistics class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
kmStatistic
	"self kmStatistic editD"

	^GbtThing struct: 'KmStatistic' define: {
	 	{ #summary . 'km-statistik' }.
		{ #idNumberPolicy . #StatistikNoPolicy }.
		{ #datum . #date: . Date today}.
		{ #km . #calc: .  'sum #Kilometer' }.
		{ #startList . #enum: .  #(BooteContext PersonenContext) }.
		{ #resultList . #listOf: . self ergebnis}.
		{ #constraints . #thing: . self fahrtenConstraint}.
	}! !

!Statistics class methodsFor: 'things' stamp: 'hk 2/26/2017 15:06'!
kmStatisticBoote
	"self kmStatisticBoote editD"
	
	| constraint |
	constraint := (self fahrtenConstraint copyWithName: #BooteConstraint)
		begin:  '1.1.2016' ;
		end: '12.31.2016' ;
		removeSmart: #wer;		"darf nicht nach Ruderern fragen"
		yourself.
	
	^(self kmStatistic copyWithName: #KmStatisticBoote)
		summary: 'Boote-Statistik';
		startList: #BooteContext ;		"startet mit der Booteliste"
		constraints: constraint;
		yourself

! !

!Statistics class methodsFor: 'things' stamp: 'hk 2/26/2017 15:06'!
kmStatisticRuderer
	"self kmStatisticRuderer editD"
	
	| constraint |
	constraint := (self fahrtenConstraint copyWithName: #RudererConstraint)
		begin:  '1.1.2016' ;
		end: '12.31.2016' ;
		removeSmart: #welches;	"darf nicht nach Booten fragen"
		yourself.
	
	^(self kmStatistic copyWithName: #KmStatisticRuderer)
		summary: 'Ruderer-Statistik';
		startList: #PersonenContext ;		"startet mit der Personenliste"
		constraints: constraint;
		yourself

! !

!Statistics class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:24'!
statisticContext
	^ GbtPlainAC struct: 'StatisticContext' define:
			{{#displayAs: . 'Statistik'}.
			{#uiSpec:icon: . #GbtItemWithTabsUI . #statistics}.
			{#aspect:on:. self ergebnisseContext. #resultList}.
			{#menu: . #'km-Statistik'}.
			{#behavior:actions:. #'km-Statistik'.
				#(#ASSURETH #void 
				  #MAPBL #FahrtenBuchContext 
				  #READSLOT #(#constraints #vConstr) 
				  #FILTER #vConstr 
				  #ALTER #(#void #Ergebnis) 
				  #REDUCE #(#thing #resultList))}}! !

!Statistics class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:25'!
statisticsContext 
	self createGlobals .
	
	^GbtBigListAC struct: 'StatisticsContext'  define: {
		{#displayAs: . 'Statistiken'} .
		{#noPolicyPrefix: . 'Stat'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #statistics} .
		{#templates: . self kmStatistic } .
		{#loadPolicy: . #simpleload } .
		{#display: . #(km ruderer boot datum begin end summary)} .
		{#subcontext: . self statisticContext}.
		{#menu: . #'Run Statistics' }.
		{#behavior:actions: . #'Run Statistics' . 
			#(ASSIGN #( #(KmStatisticBoote KmStatisticRuderer) stats)
			ASKFROM #(stats thing)							"get the relevant statistics from user -> thing"
			READSLOT #(startList vBLc)					"read context name of big list -> vBLc"
			MAPBL vBLc 											"map big list of vBLc"
			ALTER  #(thing TransformStatistic) 			"transform all list elements using TransformStatisticDecl source: pipe thing (the template)"
			APPLY #(StatisticContext 'km-Statistik')	"apply behavior to all list elements"
			ADDBL StatisticsContext) }.						"add the result list"
	}
! !

!Statistics class methodsFor: 'declaratives' stamp: 'hk 3/14/2017 13:01'!
transformStatisticDecl
	"erzeugt die Statistiken aus den Elementen einer Liste von Personen / Booten und der Ausgangsstatistik"
	
	| constraint |	
	(self fahrtenConstraint copyWithName: #NewFahrtenConstraint)		"we want a filled constraint for further editing/evaluations"
		removeSmart: #wer;
		removeSmart: #welches.
	constraint := GbtDeclarative struct: 'NewFahrtenConstraint' define: {
		{ #begin }.
		{ #end }.
		{ #gtBegin } .
		{ #ltEnd }.
		{ #boot . #tag: . #Bootsname}.
		{ #welches }.
		{ #ruderer . #tag: . #Nachname}.
		{ #fahrtenBesatzung }.
		{ #wer }.
	}.
	self kmStatistic copyWithName: #TransformStatistic.		"we need the bizId of a new kmStatistic"
	^GbtDeclarative struct: 'TransformStatistic' define: {
	 	{ #summary }.
		{ #idNumberPolicy }.
		{ #datum }.
		{ #km }.
		{ #startList }.
		{ #resultList }.
		{ #constraints . #decl: . constraint }
	} ! !
